
#include "info_reversingproject_jsimplecalculator_JSimpleCalculator.h"
#include "cobcall.h"
#include <stdio.h>
#include <string.h>

/*
 * Class:     info_reversingproject_jsimplecalculator_JSimpleCalculator
 * Method:    smplCalcXmlInterface
 * Signature: (Ljava/lang/String;)Ljava/lang/String;
 */
jstring JNICALL Java_info_reversingproject_jsimplecalculator_JSimpleCalculator_smplCalcXmlInterface
  (JNIEnv *env, jobject parent_obect, jstring xml_doc)
{
  // Get input XML document passed from Java
  jboolean iscopy;
  jstring output_xml;
  char *xml_buffer = NULL;
  char *xml_buffer_ptr = NULL;
  const char *xml_input = (*env)->GetStringUTFChars(env, xml_doc, &iscopy);
  int xml_len = strlen(xml_input);
  // Allocate XML I/O buffer and copy input XML
  xml_buffer = (char*)malloc(32767);
  memset(xml_buffer, 0x00, 32767); // Initialize
  memcpy(xml_buffer, xml_input, xml_len);
  // Free JNI memory used for MBCS to SBCS conversion
  (*env)->ReleaseStringUTFChars(env, xml_doc, &iscopy);
  // call COBOL to XML marshalling layer, passing XML I/O buffer
  cobinit(); // Initialize Micro Focus COBOL runtime
  XML2CALC(&xml_len, xml_buffer); // Call COBOL
  // Null terminate XML returned from COBOL
  xml_buffer_ptr = xml_buffer;
  xml_buffer_ptr += xml_len;
  *(xml_buffer_ptr) = 0x00;
  // Allocate UTF version of XML to return to Java
  output_xml = (*env)->NewStringUTF(env, xml_buffer);
  // Free XML I/O buffer
  free(xml_buffer);
  // Return XML generated by COBOL as Java String
  return output_xml;
}
