       $set preprocess(prexml) warn endp
      ******************************************************************
      ** Wrapper program that provides an XML interface to SMPLCALC   **
      ******************************************************************
       IDENTIFICATION DIVISION.
        PROGRAM-ID. 'XML2CALC'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      * Input/Output data structure
       01 SMPLCALC-INTERFACE.
          02 SI-OPERAND-1 PIC S9(9) COMP-5.
          02 SI-OPERAND-2 PIC S9(9) COMP-5.
          02 SI-OPERATION PIC X.
             88 DO-ADD VALUE '+'.
             88 DO-SUB VALUE '-'.
             88 DO-MUL VALUE '*'.
          02 SI-RESULT PIC S9(18) COMP-5.
          02 SI-RESULT-MESSAGE PIC X(128).
      * XML parsing state
       01 XML-PARSE-STATE.
          02 CURR-ELE-NAME PIC X(256).
          02 CURR-ELE-CONT PIC X(256).
       LINKAGE SECTION.
       01 XML-DOC-LEN  PIC S9(9) COMP-5.
       01 XML-DOC-TXT  PIC X(32767).
       PROCEDURE DIVISION USING XML-DOC-LEN XML-DOC-TXT.
       MAINLINE SECTION.
      * Parse XML into SMPLCALC-INTERFACE
           XML PARSE XML-DOC-TXT(1:XML-DOC-LEN)
               PROCESSING PROCEDURE XML-HANDLER
           END-XML
      * Invoke legacy COBOL application SMPLCALC
           CALL 'SMPLCALC' USING SMPLCALC-INTERFACE
      * Generate XML from SMPLCALC-INTERFACE
           XML GENERATE XML-DOC-TXT FROM SMPLCALC-INTERFACE
               COUNT IN XML-DOC-LEN
           END-XML
      * Return to client program
           GOBACK
           .
      * +--------------------------------------------------------------+
      * | XML event handler for marshalling XML into COBOL data        |
      * +--------------------------------------------------------------+
       XML-HANDLER.
           EVALUATE XML-EVENT
             WHEN 'START-OF-ELEMENT'
               MOVE XML-TEXT TO CURR-ELE-NAME
             WHEN 'CONTENT-CHARACTERS'
               EVALUATE CURR-ELE-NAME
                 WHEN 'SI-OPERAND-1'
                   MOVE FUNCTION NUMVAL(XML-TEXT) TO SI-OPERAND-1
                 WHEN 'SI-OPERAND-2'
                   MOVE FUNCTION NUMVAL(XML-TEXT) TO SI-OPERAND-2
                 WHEN 'SI-OPERATION'
                   MOVE XML-TEXT TO SI-OPERATION
               END-EVALUATE
             WHEN 'END-OF-ELEMENT'
               INITIALIZE CURR-ELE-NAME
           END-EVALUATE
           .
       END PROGRAM 'XML2CALC'.
